/*
 * main.h
 *
 * Created: 12-Jul-16 15:01:16
 *  Author: maticpi
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#include <avr/io.h>
#include "config.h"
#include "UART0_IRQ.h"
#include "UART1_IRQ.h"
#include "systime.h"
#include "LCD.h"
#include "kbd.h"

void Init_IO();
void ProcessMessagesFromLEDdriver();
void ProcessMessagesFromBluetooth();
void UpdateStatus();
void ProcessKeyboardEvents();

#define INHIBIT_PORT	PORTD
#define INHIBIT_BIT		4
#define LED_Power_ON()	INHIBIT_PORT &= ~(1<<INHIBIT_BIT)
#define LED_Power_OFF()	INHIBIT_PORT |= (1<<INHIBIT_BIT)

#define UVAB_ID_PIN	PIND
#define UVAB_ID_BIT	6
#define IsUVA()	(!(UVAB_ID_PIN & (1<<UVAB_ID_BIT)))
#define IsUVB()	  (UVAB_ID_PIN & (1<<UVAB_ID_BIT))
#define TYPE_UVA	0
#define TYPE_UVB	1

extern uint8_t UVtype;
extern uint8_t reportedUVtype;
extern uint8_t UVstatus;
extern uint32_t statusTimeStamp;
extern uint32_t ElapsedTime;

#define LEDS_STATUS_UNKNOWN		0x00
#define LEDS_ON10				0x01
#define LEDS_ON30				0x02
#define LEDS_ON100				0x03
#define LEDS_OFF				0x04	
#define LEDS_STATUS_OUTDATED	0x05
#define LEDS_STATUS_REFRESH		0x06	//only used by oldStatus to print status for the first time
#define LEDS_ON10_OVERTEMP		0x07
#define LEDS_ON30_OVERTEMP		0x08
#define LEDS_ON100_OVERTEMP		0x09
#define LEDS_NO_POWER			0x0E
#define LEDS_ERROR				0x0F

#define LONG_MSG_STATUS	1
#define LONG_MSG_CONFIG	2
#define LONG_MSG_NOT	0

extern uint8_t UVtype;
extern uint8_t reportedUVtype;
extern uint8_t UVstatus;
extern uint8_t mode;
#define MODE_DEFAULT	0
#define MODE_TIMER		1
#define MODE_DOSE		2
extern uint32_t statusTimeStamp;
extern uint32_t ElapsedTime;
extern float LEDpowerDensityHigh;		//Units are mW/m2 (CIE weighted)
extern float LEDpowerDensityMedium;
extern float LEDpowerDensityLow;
extern int TempLED, TempAlu;
extern float doseCountdown;
extern int32_t timerCountdown;
extern float K;

#endif /* MAIN_H_ */