/*
 * Temperature.c
 *
 * Created: 08-Aug-16 08:35:01
 *  Author: maticpi
 */ 

#include "Temperature.h"

int tempAlu, tempLED;
int ADCAlu,ADCLED;

void InitTemperature()
{
	//SHT25 - I2C
	// NAPAKA NA PCB-ju: napajanje je 5V namesto 3.3V - zato ga ne bomo uporabili
	//NTC - ADC
	PORTA &=~ ((1<<3) | (1<<4));
	DDRA &=~ ((1<<3) | (1<<4));
	DIDR0 |= (1<<3) | (1<<4);
	
	ADMUX = (3<<REFS0);
	ADCSRA = (1<<ADEN) | (7<<ADPS0);
}

void ReadNTCtemperature()
{
	int tmp;
	ADMUX = (ADMUX & 0xE0) | 3;	//select LED NTC
	_delay_us(5);
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC)) {}	//wait for conversion to complete
	tmp = ADC;
	ADCLED=tmp;
	tempLED = (int)(1.0/(log(((float)tmp)/((float)(2000-tmp)))/3428.0+1.0/298.0))-273;
	
	ADMUX = (ADMUX & 0xE0) | 4;	//select Alu NTC
	_delay_us(5);
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC)) {}	//wait for conversion to complete
	tmp = ADC;
	ADCAlu=tmp;
	tempAlu = (int)(1.0/(log(((float)tmp)/((float)(2000-tmp)))/3428.0+1.0/298.0))-273;
}