/*
 * main.h
 *
 * Created: 12-Jul-16 15:01:16
 *  Author: maticpi
 */ 


#ifndef MAIN_H_
#define MAIN_H_

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "config.h"
#include "UART0_IRQ.h"
#include "systime.h"
#include "TLC59401.h"
#include "usage_statistics.h"
#include <util/delay.h>
#include "Temperature.h"

void Init_IO();
void ReportStatus();
void ReportCalibratedPowerDensities();
void SelfDiagnostic();
void ParseSetTimerCommand();
void ParseSetDoseCommand();
void CountDown();
void PrintEEPROMData();
void ValidateCommandAndResetUsageCounter();

#define UVAB_ID_PORT	PORTC
#define UVAB_ID_DDR		DDRC
#define UVAB_ID_PIN		PINC
#define UVAB_ID_BIT		4

#define IsUVA()	(!(UVAB_ID_PIN & (1<<UVAB_ID_BIT)))
#define IsUVB()	  (UVAB_ID_PIN & (1<<UVAB_ID_BIT))
#define TYPE_UVA	0
#define TYPE_UVB	1

extern uint16_t Err1LOD,Err2LOD;
extern uint8_t ErrSignal_TEF;
extern uint8_t mode;
#define MODE_DEFAULT	0
#define MODE_TIMER		1
#define MODE_DOSE		2

extern float dose;
extern float K;			//Correction factor
extern int32_t timer;

#endif /* MAIN_H_ */