/*
 * usage_statistics.h
 *
 * Created: 24-Jul-16 20:52:01
 *  Author: maticpi
 */ 


#ifndef USAGE_STATISTICS_H_
#define USAGE_STATISTICS_H_

#include <avr/io.h>
#include <avr/eeprom.h>
#include <util/atomic.h>
#include "config.h"
#include "main.h"

void InitUsageCounters();
void UpdateUsage();
void StoreUsageData(uint8_t invalidate);
void SaveBackupUsageData();
void CheckBackupUsageData();
void InvalidateBackedupUsageData();
void EEPROM_WriteOnly_byte(uint8_t *__p, uint8_t __value);
void EEPROM_Erase_byte(uint8_t *__p);
uint8_t EEPROM_ClearFirstAvailableBit(uint8_t* __adr);

//void PrintEEPROMusgData();
//void EraseUsageEEPROM();

extern uint32_t elapsedTime;
extern uint32_t usageCounter;
#endif /* USAGE_STATISTICS_H_ */